#!/usr/bin/perl
#####################################################################################################################################
#
# DynDNS module for webmin
# Written by Giovanni Beltrame, 2002
# This module is GPL licensed
#
#####################################################################################################################################

require './dyndns-lib.pl';

# Parse arguments
&ReadParse();

# Check if domain has to be read from form or config file
$j = 1 unless $j = $in{'number'};
$dyndns_config{"DYNDNS_PROVIDER_$j"}=$in{"domains"} if $in{"domains"};
$dyndns_config{"DYNDNS_USER_$j"} = $in{"username"} if  $in{"username"};
$dyndns_config{"DYNDNS_PASSWORD_$j"}  = $in{"passwd"} if $in{"passwd"};
$dyndns_config{"DYNDNS_DOMAIN_$j"} = $in{"domain"} if $in{"domain"};
$dyndns_config{"DYNDNS_HOST_$j"} = $in{"hostname"} if $in{"hostname"};
my $secret = encode($dyndns_config{"DYNDNS_USER_$j"}.":".$dyndns_config{"DYNDNS_PASSWORD_$j"});
chomp( $secret );
$dyndns_config{"DYNDNS_SECRET_$j"} = $secret;
$dyndns_config{"DYNDNS_N"} = $in{'number'} if $in{'number'} > $dyndns_config{"DYNDNS_N"} ;

# Save or remove entry if necessary

if( $in{'save'} ) {
  &save();
  &redirect( "index.cgi" );
}


if( $in{'remove'} ) {
  &remove($j);
  &redirect( "index.cgi" );
}

&header( "Dynamic DNS Provider" , "");

print "\n<hr><table border width=100%>\n<tr $tb><td colspan=2>Data for account #$j</td>\n";

# Start form, where domains is used to store the selected provider in order to display correct domains
print <<HTML;
  <tr $cb><td><table><br>
  <form name="form1" method="post" action="entry.cgi?number=$j">
  <input type="hidden" name="save" value=0>
  <input type="hidden" name="remove" value=0>
  <input type="hidden" name="domains" value="$dyndns_config{"DYNDNS_PROVIDER_$j"}"><tr $cb><td width=25%>Provider:</td><td>
  <select name="provider" onchange="domains.value = provider.selectedIndex+1 ; document.form1.submit()">
HTML

# Check the selected provider for domains
$i = 1;
$providern = $provider_config{'PROVIDER_N'};

# Each domain is an option
while ( $i <=  $providern ) {
  print '<option ';
  print 'selected' if  $dyndns_config{"DYNDNS_PROVIDER_$j"} == $i ;
  print ">" . $provider_config{"PROVIDER_".$i."_NAME"} . "</option>";
  $i++;
}


# Other important fields: username, hostname and password
  print <<HTML;
  </select>
</td></tr><tr $cb>
  <td>Username:</td><td><input name="username" value="$dyndns_config{"DYNDNS_USER_$j"}" type="text" maxlength="30"></td></tr><tr $cb>
  <td>Password:</td><td><input name="passwd" value="$dyndns_config{"DYNDNS_PASSWORD_$j"}" type="password" maxlength="30"></td><tr $cb>
  <td>Hostname:</td><td><input name="hostname" value="$dyndns_config{"DYNDNS_HOST_$j"}" type="text" maxlength="30"></td><tr $cb>
  <td>Domain:</td><td>
  <select name="domain"
HTML

# Cycle to all the domains belonging to a given provider and display each as an option
$i = 1;
$domainn = $provider_config{"PROVIDER_" . $dyndns_config{"DYNDNS_PROVIDER_$j"} . "_DOMAIN_N"};
if( !$domainn )
  {
    print " disabled>";
  }
else
  {
    print " >";
  }
while ( $i <=  $domainn ) {
  print '<option ';
  print 'selected' if $provider_config{"PROVIDER_".$dyndns_config{"DYNDNS_PROVIDER_$j"}."_DOMAIN_$i"}  eq $dyndns_config{"DYNDNS_DOMAIN_$j"};
  print ">" . $provider_config{"PROVIDER_".$dyndns_config{"DYNDNS_PROVIDER_$j"}."_DOMAIN_$i"} . "</option>\n";
  $i++;
}

print "</select></td></tr></table><br>";

print "</td></tr></table><hr>\n<input type=\"submit\" value=\"Save\" onClick=\"save.value=1\">\n";
print "&nbsp;<input type=\"submit\" value=\"Remove\" onClick=\"remove.value=1\"></form><br>&nbsp;\n";

&footer( "" , "module index" );
